import express from 'express';
import bodyParser from 'body-parser';
import Database from './db/database';
import fs from 'fs';
import authenticateJWT from './lib/authenticateJWT';

const app = express();

app.use(bodyParser.urlencoded({extended : true}));
app.use(bodyParser.json());

// const db = new Database();

// type User = {
//     username: string,
//     password: string,
//     role: string,
//     xp: number
// };

const routes = 'routes';

fs.readdirSync(routes).forEach((file: string) => {
    const route = require(`./${routes}/${file}`);
    app.use(`/${file.split('.')[0]}`, route.default);
});









app.get('/', (req, res) => {
    res.json({ message: 'Hello World!' });
});



app.get('/test', authenticateJWT, (req, res) => {
    //@ts-ignore
    res.json({ code: 200, message: `O chuj, zalogowałeś się ${req.user.username}!` });
});

app.get('/db', (req, res) => {
    const db = new Database();
    db.query('INSERT INTO words VALUES (NULL, "kot", "猫", "animals", "neko")', []);

    res.sendStatus(200);
});

app.listen(3000, () => {
    console.log('Running on http://localhost:3000');
});